<?php
$value_file = "value.txt";

// reading the file
// fopen() supports several different modes when opening a file:
// Modes	Description
//  r	    Open file for read only. File pointer at the beginning.
//  w	    Open file for write only. Erases contents or create new file.
//  a	    Open file for write only. Existing data in file is preserved.
//  x	    Create new file for write only. File exists: Returns FALSE and error.
//  r+    Open file for read/write. File pointer at the beginning.
//  w+    Open file for read/write. Erases contents or create new file.
//  a+    Open file for read/write. Existing data in file is preserved.
//  x+    Create new file for read/write. File exists: Returns FALSE and error.

// Read thev value stored in $value_file and returns it. If value could not be
// read or is invalid and not numeric, -1 is returned.
function get_value() {
  global $value_file;
  $filename = $value_file;

  if (file_exists($filename) && ($fp = fopen($filename, "r")) !== false) {
    $counter_value = fgets($fp);
    fclose($fp);

    if (strlen(trim($counter_value)) == 0) {
      return -1;
    }
    elseif (!is_numeric($counter_value)) {
      return -1;
    }
    else {
      return $counter_value;
    }
  }
  else
  {
    return -1;
  }
}

// Set a new value, store it into $value_file and return it after closing the
// file. If the file could not be written, -1 is returned.
function set_value($new_value) {
  global $value_file;
  $filename = $value_file;

  // sanity checks
  if (strlen(trim($new_value)) == 0) {
    $new_value = 0;
  }
  elseif (!is_numeric($new_value)) {
    $new_value = 0;
  }

  // write to file
  if (file_exists($filename) && ($fp = fopen($filename, "w")) !== false) {
    fwrite($fp, $new_value);
    fclose($fp);
    return $new_value;
  }
  else
  {
    return -1;
  }
}

// Executes the shell script that updates the LOAD value in OneGate
function update_onegate() {
  $script = "./update_onegate.sh";
  system($script, $retval);
  return $retval;
}

?>
